function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

function pipeP() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function (value) {
    return new Promise(function (resolve, reject) {
      (function () {
        var _run = _asyncToGenerator(
        /*#__PURE__*/
        runtime_1.mark(function _callee(_ref, value) {
          var f, fns;
          return runtime_1.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  f = _ref[0], fns = _ref.slice(1);
                  _context.prev = 1;

                  if (!(f === undefined)) {
                    _context.next = 6;
                    break;
                  }

                  resolve(value);
                  _context.next = 12;
                  break;

                case 6:
                  _context.t0 = run;
                  _context.t1 = fns;
                  _context.next = 10;
                  return f(value);

                case 10:
                  _context.t2 = _context.sent;
                  (0, _context.t0)(_context.t1, _context.t2);

                case 12:
                  _context.next = 17;
                  break;

                case 14:
                  _context.prev = 14;
                  _context.t3 = _context["catch"](1);
                  reject(_context.t3);

                case 17:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[1, 14]]);
        }));

        function run(_x, _x2) {
          return _run.apply(this, arguments);
        }

        return run;
      })()(fns, value);
    });
  };
}
var tryCatchP = function tryCatchP(trier, catcher) {
  return (
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      runtime_1.mark(function _callee2(value) {
        return runtime_1.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return trier(value);

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 6:
                _context2.prev = 6;
                _context2.t0 = _context2["catch"](0);
                _context2.next = 10;
                return catcher(_context2.t0, value);

              case 10:
                return _context2.abrupt("return", _context2.sent);

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[0, 6]]);
      }));

      return function (_x3) {
        return _ref2.apply(this, arguments);
      };
    }()
  );
};

var newError = function newError(id, message, res) {
  var error = new Error(message);
  error.id = id;
  if (res) error.res = res;
  return error;
};

var errorIds = {
  RetryError: 'RetryError',
  TimeoutError: 'TimeoutError',
  DecodeResponseError: 'DecodeResponseError',
  InvalidStatusCodeError: 'InvalidStatusCodeError'
};
var delay = function delay(time) {
  return new Promise(function (resolve) {
    setTimeout(function () {
      return resolve();
    }, time);
  });
};

var delayedFail = function delayedFail(timeout) {
  return delay(timeout).then(function () {
    throw newError(errorIds.TimeoutError, 'Timeout');
  });
};

var tapAndDelay = function tapAndDelay(f, time) {
  f(time);
  return delay(time);
};

var nothing = function nothing() {
  return undefined;
};

var delays = {
  delay: delay,
  tapAndDelay: tapAndDelay,
  constant: function constant(time, f) {
    if (time === void 0) {
      time = 1000;
    }

    if (f === void 0) {
      f = nothing;
    }

    return function () {
      return tapAndDelay(f, time);
    };
  },
  exponential: function exponential(time, f) {
    if (time === void 0) {
      time = 1000;
    }

    if (f === void 0) {
      f = nothing;
    }

    return function (i) {
      return tapAndDelay(f, i * i * time);
    };
  },
  limited: function limited(max, delay) {
    return function (i) {
      return delay((i - 1) % max + 1);
    };
  },
  linear: function linear(time, f) {
    if (time === void 0) {
      time = 1000;
    }

    if (f === void 0) {
      f = nothing;
    }

    return function (i) {
      return tapAndDelay(f, i * time);
    };
  }
};
var withBaseUrl = function withBaseUrl(baseUrl) {
  return function (req) {
    req.url = baseUrl + req.url;
    return req;
  };
};
var withHeader = function withHeader(header, value) {
  return function (req) {
    if (req.headers && req.headers instanceof Headers) {
      if (req.headers.has(header)) req.headers.append(header, value);else req.headers.set(header, value);
    } else {
      req.headers = req.headers || {};
      req.headers[header.toLowerCase()] = value;
    }
    return req;
  };
};
var withCredentials = function withCredentials(value) {
  return function (req) {
    req.credentials = value;
    return req;
  };
};
var withEncodedBody = function withEncodedBody(encoder) {
  return function (req) {
    if (req.method && req.method.toLowerCase() !== 'get' && req.body) req.body = encoder(req.body);
    return req;
  };
};
var withJSONEncodedBody =
/*#__PURE__*/
withEncodedBody(JSON.stringify);
var fetch1 = function fetch1(fetch) {
  return function (req) {
    return fetch(req.url, req);
  };
};
var retryable = function retryable(fetch) {
  return function (req) {
    return (
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      runtime_1.mark(function _callee3() {
        var retryableErrors, retryableStatuses, throwError, res;
        return runtime_1.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                retryableErrors = new Set(['ETIMEDOUT', 'ECONNRESET', 'EADDRINUSE', 'ECONNREFUSED', 'EPIPE', 'ENOTFOUND', 'ENETUNREACH', 'EAI_AGAIN']);
                retryableStatuses = new Set([408, 413, 429, 500, 502, 503, 504]);

                throwError = function throwError(res) {
                  throw newError(errorIds.RetryError, 'Retry error', res);
                };

                _context3.prev = 3;
                _context3.next = 6;
                return fetch(req);

              case 6:
                res = _context3.sent;
                if (retryableStatuses.has(res.status)) throwError(res);
                return _context3.abrupt("return", res);

              case 11:
                _context3.prev = 11;
                _context3.t0 = _context3["catch"](3);
                if (retryableErrors.has(_context3.t0.code)) throwError();
                throw _context3.t0;

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[3, 11]]);
      }))
    );
  };
};
/**
 * @deprecated 6.0.0
 */

var withTimeout = function withTimeout(timeout) {
  return function (fetch) {
    return function () {
      return Promise.race([fetch(), delayedFail(timeout)]);
    };
  };
};
var decodeRetryAfterHeaderValue = function decodeRetryAfterHeaderValue(response) {
  var value = response && response.headers.get('retry-after');

  if (typeof value === 'string') {
    // node-fetch workaround
    // it converts number to string
    var parsed = parseInt(value, 10);
    if ("" + parsed === value) return parsed;
    return new Date(value).getTime() - Date.now();
  }

  if (typeof value === 'number') return value;
  return undefined;
};
var withRetry = function withRetry(_temp) {
  var _ref4 = _temp === void 0 ? {} : _temp,
      _ref4$max = _ref4.max,
      max = _ref4$max === void 0 ? 5 : _ref4$max,
      _ref4$delay = _ref4.delay,
      delay = _ref4$delay === void 0 ? delays.linear() : _ref4$delay,
      _ref4$maxTimeout = _ref4.maxTimeout,
      maxTimeout = _ref4$maxTimeout === void 0 ? Number.MAX_VALUE : _ref4$maxTimeout;

  return function (fetch) {
    return new Promise(function (resolve, reject) {
      (function () {
        var _run2 = _asyncToGenerator(
        /*#__PURE__*/
        runtime_1.mark(function _callee4(i) {
          var retryAfter;
          return runtime_1.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  if (!(i === max + 1)) {
                    _context4.next = 4;
                    break;
                  }

                  reject(newError(errorIds.RetryError, 'Retry failed'));
                  _context4.next = 24;
                  break;

                case 4:
                  _context4.prev = 4;
                  _context4.t0 = resolve;
                  _context4.next = 8;
                  return fetch();

                case 8:
                  _context4.t1 = _context4.sent;
                  (0, _context4.t0)(_context4.t1);
                  _context4.next = 24;
                  break;

                case 12:
                  _context4.prev = 12;
                  _context4.t2 = _context4["catch"](4);

                  if (!(_context4.t2.id !== errorIds.RetryError)) {
                    _context4.next = 17;
                    break;
                  }

                  reject(_context4.t2);
                  return _context4.abrupt("return");

                case 17:
                  retryAfter = decodeRetryAfterHeaderValue(_context4.t2.res);

                  if (!(retryAfter > maxTimeout)) {
                    _context4.next = 21;
                    break;
                  }

                  reject(newError(errorIds.RetryError, 'Retry-after is higher than maxTimeout'));
                  return _context4.abrupt("return");

                case 21:
                  _context4.next = 23;
                  return retryAfter === undefined ? delay(i) : delays.delay(retryAfter);

                case 23:
                  run(i + 1);

                case 24:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, null, [[4, 12]]);
        }));

        function run(_x4) {
          return _run2.apply(this, arguments);
        }

        return run;
      })()(1);
    });
  };
};
var withSafe204 = function withSafe204(text, json) {
  if (text === void 0) {
    text = '';
  }

  if (json === void 0) {
    json = {};
  }

  return function (res) {
    if (res.status === 204) {
      res.text =
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      runtime_1.mark(function _callee5() {
        return runtime_1.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt("return", text);

              case 1:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));
      res.json =
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      runtime_1.mark(function _callee6() {
        return runtime_1.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt("return", json);

              case 1:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));
    }

    return res;
  };
};
var withClone = function withClone(res) {
  res.cloned = res.clone();
  return res;
};
var decodeResponse = function decodeResponse(res) {
  var contentType = res.headers.get('content-type') || '';
  if (contentType.indexOf('application/json') === 0) return decodeJSONResponse(res);
  if (contentType.indexOf('application/x-www-form-urlencoded') === 0) return decodeFormDataResponse(res);
  if (contentType.indexOf('text/') === 0) return decodeTextResponse(res);
  return res;
};
var decodeTextResponse =
/*#__PURE__*/
function () {
  var _ref7 =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  runtime_1.mark(function _callee7(res) {
    return runtime_1.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 3;
            return res.text();

          case 3:
            res.data = _context7.sent;
            return _context7.abrupt("return", res);

          case 5:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));

  return function decodeTextResponse(_x5) {
    return _ref7.apply(this, arguments);
  };
}();
var decodeJSONResponse =
/*#__PURE__*/
function () {
  var _ref8 =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  runtime_1.mark(function _callee8(res) {
    return runtime_1.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.prev = 0;
            _context8.next = 4;
            return res.json();

          case 4:
            res.data = _context8.sent;
            return _context8.abrupt("return", res);

          case 8:
            _context8.prev = 8;
            _context8.t0 = _context8["catch"](0);
            throw newError(errorIds.DecodeResponseError, _context8.t0.message, res);

          case 11:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, null, [[0, 8]]);
  }));

  return function decodeJSONResponse(_x6) {
    return _ref8.apply(this, arguments);
  };
}();
var decodeFormDataResponse =
/*#__PURE__*/
function () {
  var _ref9 =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  runtime_1.mark(function _callee9(res) {
    return runtime_1.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.prev = 0;
            _context9.next = 4;
            return res.formData();

          case 4:
            res.data = _context9.sent;
            return _context9.abrupt("return", res);

          case 8:
            _context9.prev = 8;
            _context9.t0 = _context9["catch"](0);
            throw newError(errorIds.DecodeResponseError, _context9.t0.message, res);

          case 11:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9, null, [[0, 8]]);
  }));

  return function decodeFormDataResponse(_x7) {
    return _ref9.apply(this, arguments);
  };
}();
var decodeArrayBufferResponse =
/*#__PURE__*/
function () {
  var _ref10 =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  runtime_1.mark(function _callee10(res) {
    return runtime_1.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _context10.next = 3;
            return res.arrayBuffer();

          case 3:
            res.data = _context10.sent;
            return _context10.abrupt("return", res);

          case 5:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10);
  }));

  return function decodeArrayBufferResponse(_x8) {
    return _ref10.apply(this, arguments);
  };
}();
var decodeBlobResponse =
/*#__PURE__*/
function () {
  var _ref11 =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  runtime_1.mark(function _callee11(res) {
    return runtime_1.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            _context11.next = 3;
            return res.blob();

          case 3:
            res.data = _context11.sent;
            return _context11.abrupt("return", res);

          case 5:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11);
  }));

  return function decodeBlobResponse(_x9) {
    return _ref11.apply(this, arguments);
  };
}();
var checkStatus = function checkStatus(res) {
  if (res.status < 200 || res.status >= 400) throw newError(errorIds.InvalidStatusCodeError, 'Invalid status code: ' + res.status, res);
  return res;
};

var formatError =
/*#__PURE__*/
function () {
  var _ref12 =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  runtime_1.mark(function _callee12(error, x) {
    var formatted, append, message, id, errors, res, awaitingErrors, formattedErrors;
    return runtime_1.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            if (x === void 0) {
              x = 'Fetch error';
            }

            formatted = '';

            append = function append(line, empty) {
              if (empty === void 0) {
                empty = false;
              }

              var n = empty ? '\n' : '';
              formatted += n + line + '\n' + n;
            };

            message = error.message, id = error.id, errors = error.errors, res = error.res;
            append(x + (id ? " [" + id + "]: " : ': ') + message);

            if (!(id === errorIds.RetryError)) {
              _context12.next = 13;
              break;
            }

            awaitingErrors = errors.map(function (error, i) {
              return formatError(error, "retry: [" + i + "]");
            });
            _context12.next = 9;
            return Promise.all(awaitingErrors);

          case 9:
            formattedErrors = _context12.sent;
            append(formattedErrors.join(''), true);
            _context12.next = 24;
            break;

          case 13:
            if (!(id === errorIds.DecodeResponseError || id === errorIds.InvalidStatusCodeError)) {
              _context12.next = 24;
              break;
            }

            if (!res.data) {
              _context12.next = 18;
              break;
            }

            append(res.data, true);
            _context12.next = 24;
            break;

          case 18:
            if (!res.cloned) {
              _context12.next = 24;
              break;
            }

            _context12.t0 = append;
            _context12.next = 22;
            return res.cloned.text();

          case 22:
            _context12.t1 = _context12.sent;
            (0, _context12.t0)(_context12.t1, true);

          case 24:
            return _context12.abrupt("return", formatted);

          case 25:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12);
  }));

  return function formatError(_x10, _x11) {
    return _ref12.apply(this, arguments);
  };
}();

var logError = function logError(log) {
  if (log === void 0) {
    log = console.error.bind(console);
  }

  return (
    /*#__PURE__*/
    function () {
      var _ref13 = _asyncToGenerator(
      /*#__PURE__*/
      runtime_1.mark(function _callee13(error) {
        return runtime_1.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.t0 = log;
                _context13.next = 3;
                return formatError(error);

              case 3:
                _context13.t1 = _context13.sent;
                (0, _context13.t0)(_context13.t1);
                throw error;

              case 6:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13);
      }));

      return function (_x12) {
        return _ref13.apply(this, arguments);
      };
    }()
  );
};
var json = function json(fetch, options) {
  return pipeP(withHeader('Content-Type', 'application/json'), withHeader('Accept', 'application/json'), withJSONEncodedBody, retryable(fetch1(fetch)), withRetry(options), withSafe204(), decodeJSONResponse, checkStatus);
};
var text = function text(fetch, options) {
  return pipeP(retryable(fetch1(fetch)), withRetry(options), withSafe204(), decodeTextResponse, checkStatus);
};
var abortable = function abortable() {
  var controller = new AbortController();
  var signal = controller.signal;
  return {
    signal: signal,
    abort: function abort() {
      controller.abort();
    }
  };
};
var ignoreAbortError = function ignoreAbortError(handler) {
  return function (error) {
    if (error.name === 'AbortError') return;
    return handler(error);
  };
};

export { abortable, checkStatus, decodeArrayBufferResponse, decodeBlobResponse, decodeFormDataResponse, decodeJSONResponse, decodeResponse, decodeRetryAfterHeaderValue, decodeTextResponse, delay, delays, errorIds, fetch1, ignoreAbortError, json, logError, pipeP, retryable, text, tryCatchP, withBaseUrl, withClone, withCredentials, withEncodedBody, withHeader, withJSONEncodedBody, withRetry, withSafe204, withTimeout };
//# sourceMappingURL=composable-fetch.esm.js.map
